#pragma once

// ************************** Fehlercodes *********************************************************
#define API_SUCCESS								   0		// Kein Fehler
#define API_NO_SUCCESS							   1        // Fehler - Allgemein
#define API_NO_USB_DEVICE						   2		// Fehler - Kein USB-Gert vorhanden
#define API_FILE_TO_LARGE						   3		// File to large for hd
#define API_NO_SPACE_LEFT						   -10		// No space left on device

// ************************** Einbinden von DLL ***************************************************
#ifdef BUILDING_DLL
#define DLL_API __declspec(dllexport)
#else
#define DLL_API __declspec(dllimport)
#endif

#ifdef  __cplusplus
#define EXTERN_DECL extern "C"
#else
#define EXTERN_DECL
#endif

// ************************** Strukturen **********************************************************
// a) FileInfo-Struktur
struct sFileInfo
{
	char caFileName[12];
	char caFileDate[12];
	char caFileTime[12];
	char caFileSize[24];
};
typedef struct sFileInfo sFILEINFO;

// ************************** api.cpp ************************************************************
// a) DetailInfo-DLL
EXTERN_DECL DLL_API unsigned long CCO_GetDLLInfo(char* pcaVersion, char* pcaVersionDate);

// b) Datenloggererkennung
EXTERN_DECL DLL_API unsigned long CCO_IsDatenloggerPluged(unsigned char* pbyIsPluged);

// c) Aufzeichnen
EXTERN_DECL DLL_API unsigned long CCO_RecordStart(void);
EXTERN_DECL DLL_API unsigned long CCO_RecordStop(void);
EXTERN_DECL DLL_API unsigned long CCO_RecordTrigger(void);
EXTERN_DECL DLL_API unsigned long CCO_RecordGetStatus(unsigned char* pbIsRunning, unsigned short* pwTriggerCount, unsigned short* pwRecordNr);

// d) Dateiverwaltung
EXTERN_DECL DLL_API unsigned long CCO_GetNumberOfRecords(unsigned long* pulNumberOfRecords);
EXTERN_DECL DLL_API unsigned long CCO_GetFileInfo(sFILEINFO* psFileInfo, unsigned long ulNumberOfRecords);;
EXTERN_DECL DLL_API unsigned long CCO_DeleteAllFiles(void);
EXTERN_DECL DLL_API unsigned long CCO_DeleteAllFiles_IsWorking(void);

// e) Dateidownload
EXTERN_DECL DLL_API unsigned long CCO_DownloadCancel(void);
EXTERN_DECL DLL_API   signed long CCO_DownloadGetProgress(void);
EXTERN_DECL DLL_API unsigned long CCO_DownloadStart(unsigned long ulFileNumber, char* pcaDestinationFile);
EXTERN_DECL DLL_API unsigned long CCO_DownloadStart2(unsigned long ulFileNumber);

// f) Log DLL (default: FALSE)
EXTERN_DECL	DLL_API	void CCO_LogDLL( BOOL bStatus );
